// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package spring.security.starter.web;

import java.io.UnsupportedEncodingException;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;
import spring.security.starter.model.Todo;
import spring.security.starter.web.TodoController;

privileged aspect TodoController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST, produces = "text/html")
    public String TodoController.create(@Valid Todo todo, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            populateEditForm(uiModel, todo);
            return "todoes/create";
        }
        uiModel.asMap().clear();
        todo.persist();
        return "redirect:/todoes/" + encodeUrlPathSegment(todo.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(params = "form", produces = "text/html")
    public String TodoController.createForm(Model uiModel) {
        populateEditForm(uiModel, new Todo());
        return "todoes/create";
    }
    
    @RequestMapping(value = "/{id}", produces = "text/html")
    public String TodoController.show(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("todo", Todo.findTodo(id));
        uiModel.addAttribute("itemId", id);
        return "todoes/show";
    }
    
    @RequestMapping(produces = "text/html")
    public String TodoController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            final int firstResult = page == null ? 0 : (page.intValue() - 1) * sizeNo;
            uiModel.addAttribute("todoes", Todo.findTodoEntries(firstResult, sizeNo));
            float nrOfPages = (float) Todo.countTodoes() / sizeNo;
            uiModel.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            uiModel.addAttribute("todoes", Todo.findAllTodoes());
        }
        return "todoes/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT, produces = "text/html")
    public String TodoController.update(@Valid Todo todo, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            populateEditForm(uiModel, todo);
            return "todoes/update";
        }
        uiModel.asMap().clear();
        todo.merge();
        return "redirect:/todoes/" + encodeUrlPathSegment(todo.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(value = "/{id}", params = "form", produces = "text/html")
    public String TodoController.updateForm(@PathVariable("id") Long id, Model uiModel) {
        populateEditForm(uiModel, Todo.findTodo(id));
        return "todoes/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE, produces = "text/html")
    public String TodoController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        Todo todo = Todo.findTodo(id);
        todo.remove();
        uiModel.asMap().clear();
        uiModel.addAttribute("page", (page == null) ? "1" : page.toString());
        uiModel.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/todoes";
    }
    
    void TodoController.populateEditForm(Model uiModel, Todo todo) {
        uiModel.addAttribute("todo", todo);
    }
    
    String TodoController.encodeUrlPathSegment(String pathSegment, HttpServletRequest httpServletRequest) {
        String enc = httpServletRequest.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        } catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
